diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/helper/packet-sink-helper.h ns-3.42/src/applications/helper/packet-sink-helper.h
--- ns-3.41/src/applications/helper/packet-sink-helper.h	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/helper/packet-sink-helper.h	2024-05-29 15:29:46.920073000 -0700
@@ -16,13 +16,11 @@
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
+
 #ifndef PACKET_SINK_HELPER_H
 #define PACKET_SINK_HELPER_H
 
-#include "ns3/application-container.h"
-#include "ns3/ipv4-address.h"
-#include "ns3/node-container.h"
-#include "ns3/object-factory.h"
+#include <ns3/application-helper.h>
 
 namespace ns3
 {
@@ -32,7 +30,7 @@
  * \brief A helper to make it easier to instantiate an ns3::PacketSinkApplication
  * on a set of nodes.
  */
-class PacketSinkHelper
+class PacketSinkHelper : public ApplicationHelper
 {
   public:
     /**
@@ -45,54 +43,7 @@
      * \param address the address of the sink,
      *
      */
-    PacketSinkHelper(std::string protocol, Address address);
-
-    /**
-     * Helper function used to set the underlying application attributes.
-     *
-     * \param name the name of the application attribute to set
-     * \param value the value of the application attribute to set
-     */
-    void SetAttribute(std::string name, const AttributeValue& value);
-
-    /**
-     * Install an ns3::PacketSinkApplication on each node of the input container
-     * configured with all the attributes set with SetAttribute.
-     *
-     * \param c NodeContainer of the set of nodes on which a PacketSinkApplication
-     * will be installed.
-     * \returns Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(NodeContainer c) const;
-
-    /**
-     * Install an ns3::PacketSinkApplication on each node of the input container
-     * configured with all the attributes set with SetAttribute.
-     *
-     * \param node The node on which a PacketSinkApplication will be installed.
-     * \returns Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(Ptr<Node> node) const;
-
-    /**
-     * Install an ns3::PacketSinkApplication on each node of the input container
-     * configured with all the attributes set with SetAttribute.
-     *
-     * \param nodeName The name of the node on which a PacketSinkApplication will be installed.
-     * \returns Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(std::string nodeName) const;
-
-  private:
-    /**
-     * Install an ns3::PacketSink on the node configured with all the
-     * attributes set with SetAttribute.
-     *
-     * \param node The node on which an PacketSink will be installed.
-     * \returns Ptr to the application installed.
-     */
-    Ptr<Application> InstallPriv(Ptr<Node> node) const;
-    ObjectFactory m_factory; //!< Object factory.
+    PacketSinkHelper(const std::string& protocol, const Address& address);
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/helper/three-gpp-http-helper.cc ns-3.42/src/applications/helper/three-gpp-http-helper.cc
--- ns-3.41/src/applications/helper/three-gpp-http-helper.cc	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/helper/three-gpp-http-helper.cc	2024-05-29 15:29:46.920073000 -0700
@@ -25,105 +25,23 @@
 
 #include "three-gpp-http-helper.h"
 
-#include <ns3/names.h>
-
 namespace ns3
 {
 
 // 3GPP HTTP CLIENT HELPER /////////////////////////////////////////////////////////
 
 ThreeGppHttpClientHelper::ThreeGppHttpClientHelper(const Address& address)
+    : ApplicationHelper("ns3::ThreeGppHttpClient")
 {
-    m_factory.SetTypeId("ns3::ThreeGppHttpClient");
     m_factory.Set("RemoteServerAddress", AddressValue(address));
 }
 
-void
-ThreeGppHttpClientHelper::SetAttribute(const std::string& name, const AttributeValue& value)
-{
-    m_factory.Set(name, value);
-}
-
-ApplicationContainer
-ThreeGppHttpClientHelper::Install(Ptr<Node> node) const
-{
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-ThreeGppHttpClientHelper::Install(const std::string& nodeName) const
-{
-    Ptr<Node> node = Names::Find<Node>(nodeName);
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-ThreeGppHttpClientHelper::Install(NodeContainer c) const
-{
-    ApplicationContainer apps;
-    for (auto i = c.Begin(); i != c.End(); ++i)
-    {
-        apps.Add(InstallPriv(*i));
-    }
-
-    return apps;
-}
-
-Ptr<Application>
-ThreeGppHttpClientHelper::InstallPriv(Ptr<Node> node) const
-{
-    Ptr<Application> app = m_factory.Create<Application>();
-    node->AddApplication(app);
-
-    return app;
-}
-
 // HTTP SERVER HELPER /////////////////////////////////////////////////////////
 
 ThreeGppHttpServerHelper::ThreeGppHttpServerHelper(const Address& address)
+    : ApplicationHelper("ns3::ThreeGppHttpServer")
 {
-    m_factory.SetTypeId("ns3::ThreeGppHttpServer");
     m_factory.Set("LocalAddress", AddressValue(address));
 }
 
-void
-ThreeGppHttpServerHelper::SetAttribute(const std::string& name, const AttributeValue& value)
-{
-    m_factory.Set(name, value);
-}
-
-ApplicationContainer
-ThreeGppHttpServerHelper::Install(Ptr<Node> node) const
-{
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-ThreeGppHttpServerHelper::Install(const std::string& nodeName) const
-{
-    Ptr<Node> node = Names::Find<Node>(nodeName);
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-ThreeGppHttpServerHelper::Install(NodeContainer c) const
-{
-    ApplicationContainer apps;
-    for (auto i = c.Begin(); i != c.End(); ++i)
-    {
-        apps.Add(InstallPriv(*i));
-    }
-
-    return apps;
-}
-
-Ptr<Application>
-ThreeGppHttpServerHelper::InstallPriv(Ptr<Node> node) const
-{
-    Ptr<Application> app = m_factory.Create<Application>();
-    node->AddApplication(app);
-
-    return app;
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/helper/three-gpp-http-helper.h ns-3.42/src/applications/helper/three-gpp-http-helper.h
--- ns-3.41/src/applications/helper/three-gpp-http-helper.h	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/helper/three-gpp-http-helper.h	2024-05-29 15:29:46.920073000 -0700
@@ -26,9 +26,7 @@
 #ifndef THREE_GPP_HTTP_HELPER_H
 #define THREE_GPP_HTTP_HELPER_H
 
-#include <ns3/application-container.h>
-#include <ns3/node-container.h>
-#include <ns3/object-factory.h>
+#include <ns3/application-helper.h>
 
 namespace ns3
 {
@@ -37,7 +35,7 @@
  * \ingroup applications
  * Helper to make it easier to instantiate an ThreeGppHttpClient on a set of nodes.
  */
-class ThreeGppHttpClientHelper
+class ThreeGppHttpClientHelper : public ApplicationHelper
 {
   public:
     /**
@@ -46,61 +44,13 @@
      * \param address The address of the remote server node to send traffic to.
      */
     ThreeGppHttpClientHelper(const Address& address);
-
-    /**
-     * Helper function used to set the underlying application attributes, but
-     * *not* the socket attributes.
-     * \param name The name of the application attribute to set.
-     * \param value The value of the application attribute to set.
-     */
-    void SetAttribute(const std::string& name, const AttributeValue& value);
-
-    /**
-     * Install a ThreeGppHttpClient on each node of the input container configured with
-     * all the attributes set with SetAttribute().
-     * \param c NodeContainer of the set of nodes on which an ThreeGppHttpClient
-     *          will be installed.
-     * \return Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(NodeContainer c) const;
-
-    /**
-     * Install a ThreeGppHttpClient on each node of the input container
-     * configured with all the attributes set with SetAttribute().
-     * \param node The node on which an ThreeGppHttpClient will be installed.
-     * \return Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(Ptr<Node> node) const;
-
-    /**
-     * Install a ThreeGppHttpClient on each node of the input container
-     * configured with all the attributes set with SetAttribute().
-     * \param nodeName The name of the node on which an ThreeGppHttpClient
-     *                 will be installed.
-     * \return Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(const std::string& nodeName) const;
-
-  private:
-    /**
-     * \internal
-     * Install a ThreeGppHttpClient on the node configured with all the
-     * attributes set with SetAttribute().
-     * \param node The node on which an ThreeGppHttpClient will be installed.
-     * \return Ptr to the application installed.
-     */
-    Ptr<Application> InstallPriv(Ptr<Node> node) const;
-
-    /// Used to instantiate an ThreeGppHttpClient instance.
-    ObjectFactory m_factory;
-
 }; // end of `class ThreeGppHttpClientHelper`
 
 /**
  * \ingroup http
  * Helper to make it easier to instantiate an ThreeGppHttpServer on a set of nodes.
  */
-class ThreeGppHttpServerHelper
+class ThreeGppHttpServerHelper : public ApplicationHelper
 {
   public:
     /**
@@ -109,54 +59,6 @@
      * \param address The address of the server.
      */
     ThreeGppHttpServerHelper(const Address& address);
-
-    /**
-     * Helper function used to set the underlying application attributes, but
-     * *not* the socket attributes.
-     * \param name The name of the application attribute to set.
-     * \param value The value of the application attribute to set.
-     */
-    void SetAttribute(const std::string& name, const AttributeValue& value);
-
-    /**
-     * Install an ThreeGppHttpServer on each node of the input container
-     * configured with all the attributes set with SetAttribute().
-     * \param c NodeContainer of the set of nodes on which an ThreeGppHttpServer
-     *              will be installed.
-     * \return Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(NodeContainer c) const;
-
-    /**
-     * Install an ThreeGppHttpServer on each node of the input container
-     * configured with all the attributes set with SetAttribute().
-     * \param node The node on which an ThreeGppHttpServer will be installed.
-     * \return Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(Ptr<Node> node) const;
-
-    /**
-     * Install an ThreeGppHttpServer on each node of the input container
-     * configured with all the attributes set with SetAttribute().
-     * \param nodeName The name of the node on which an ThreeGppHttpServer
-     *                             will be installed.
-     * \return Container of Ptr to the applications installed.
-     */
-    ApplicationContainer Install(const std::string& nodeName) const;
-
-  private:
-    /**
-     * \internal
-     * Install an ThreeGppHttpServer on the node configured with all the
-     * attributes set with SetAttribute().
-     * \param node The node on which an ThreeGppHttpServer will be installed.
-     * \return Ptr to the application installed.
-     */
-    Ptr<Application> InstallPriv(Ptr<Node> node) const;
-
-    /// Used to instantiate a ThreeGppHttpServer instance.
-    ObjectFactory m_factory;
-
 }; // end of `class ThreeGppHttpServerHelper`
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/helper/udp-client-server-helper.cc ns-3.42/src/applications/helper/udp-client-server-helper.cc
--- ns-3.41/src/applications/helper/udp-client-server-helper.cc	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/helper/udp-client-server-helper.cc	2024-05-29 15:29:46.920073000 -0700
@@ -16,131 +16,61 @@
  *
  * Author: Mohamed Amine Ismail <amine.ismail@sophia.inria.fr>
  */
+
 #include "udp-client-server-helper.h"
 
-#include "ns3/string.h"
-#include "ns3/udp-client.h"
-#include "ns3/udp-server.h"
-#include "ns3/udp-trace-client.h"
-#include "ns3/uinteger.h"
+#include <ns3/string.h>
+#include <ns3/uinteger.h>
 
 namespace ns3
 {
 
 UdpServerHelper::UdpServerHelper()
+    : ApplicationHelper(UdpServer::GetTypeId())
 {
-    m_factory.SetTypeId(UdpServer::GetTypeId());
 }
 
 UdpServerHelper::UdpServerHelper(uint16_t port)
+    : UdpServerHelper()
 {
-    m_factory.SetTypeId(UdpServer::GetTypeId());
     SetAttribute("Port", UintegerValue(port));
 }
 
-void
-UdpServerHelper::SetAttribute(std::string name, const AttributeValue& value)
-{
-    m_factory.Set(name, value);
-}
-
-ApplicationContainer
-UdpServerHelper::Install(NodeContainer c)
-{
-    ApplicationContainer apps;
-    for (auto i = c.Begin(); i != c.End(); ++i)
-    {
-        Ptr<Node> node = *i;
-
-        m_server = m_factory.Create<UdpServer>();
-        node->AddApplication(m_server);
-        apps.Add(m_server);
-    }
-    return apps;
-}
-
-Ptr<UdpServer>
-UdpServerHelper::GetServer()
-{
-    return m_server;
-}
-
 UdpClientHelper::UdpClientHelper()
+    : ApplicationHelper(UdpClient::GetTypeId())
 {
-    m_factory.SetTypeId(UdpClient::GetTypeId());
-}
-
-UdpClientHelper::UdpClientHelper(Address address, uint16_t port)
-{
-    m_factory.SetTypeId(UdpClient::GetTypeId());
-    SetAttribute("RemoteAddress", AddressValue(address));
-    SetAttribute("RemotePort", UintegerValue(port));
 }
 
-UdpClientHelper::UdpClientHelper(Address address)
+UdpClientHelper::UdpClientHelper(const Address& address)
+    : UdpClientHelper()
 {
-    m_factory.SetTypeId(UdpClient::GetTypeId());
     SetAttribute("RemoteAddress", AddressValue(address));
 }
 
-void
-UdpClientHelper::SetAttribute(std::string name, const AttributeValue& value)
-{
-    m_factory.Set(name, value);
-}
-
-ApplicationContainer
-UdpClientHelper::Install(NodeContainer c)
+UdpClientHelper::UdpClientHelper(const Address& address, uint16_t port)
+    : UdpClientHelper(address)
 {
-    ApplicationContainer apps;
-    for (auto i = c.Begin(); i != c.End(); ++i)
-    {
-        Ptr<Node> node = *i;
-        Ptr<UdpClient> client = m_factory.Create<UdpClient>();
-        node->AddApplication(client);
-        apps.Add(client);
-    }
-    return apps;
+    SetAttribute("RemotePort", UintegerValue(port));
 }
 
 UdpTraceClientHelper::UdpTraceClientHelper()
+    : ApplicationHelper(UdpTraceClient::GetTypeId())
 {
-    m_factory.SetTypeId(UdpTraceClient::GetTypeId());
 }
 
-UdpTraceClientHelper::UdpTraceClientHelper(Address address, uint16_t port, std::string filename)
+UdpTraceClientHelper::UdpTraceClientHelper(const Address& address, const std::string& filename)
+    : UdpTraceClientHelper()
 {
-    m_factory.SetTypeId(UdpTraceClient::GetTypeId());
     SetAttribute("RemoteAddress", AddressValue(address));
-    SetAttribute("RemotePort", UintegerValue(port));
     SetAttribute("TraceFilename", StringValue(filename));
 }
 
-UdpTraceClientHelper::UdpTraceClientHelper(Address address, std::string filename)
+UdpTraceClientHelper::UdpTraceClientHelper(const Address& address,
+                                           uint16_t port,
+                                           const std::string& filename)
+    : UdpTraceClientHelper(address, filename)
 {
-    m_factory.SetTypeId(UdpTraceClient::GetTypeId());
-    SetAttribute("RemoteAddress", AddressValue(address));
-    SetAttribute("TraceFilename", StringValue(filename));
-}
-
-void
-UdpTraceClientHelper::SetAttribute(std::string name, const AttributeValue& value)
-{
-    m_factory.Set(name, value);
-}
-
-ApplicationContainer
-UdpTraceClientHelper::Install(NodeContainer c)
-{
-    ApplicationContainer apps;
-    for (auto i = c.Begin(); i != c.End(); ++i)
-    {
-        Ptr<Node> node = *i;
-        Ptr<UdpTraceClient> client = m_factory.Create<UdpTraceClient>();
-        node->AddApplication(client);
-        apps.Add(client);
-    }
-    return apps;
+    SetAttribute("RemotePort", UintegerValue(port));
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/helper/udp-client-server-helper.h ns-3.42/src/applications/helper/udp-client-server-helper.h
--- ns-3.41/src/applications/helper/udp-client-server-helper.h	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/helper/udp-client-server-helper.h	2024-05-29 15:29:46.920073000 -0700
@@ -16,15 +16,14 @@
  *
  * Author: Mohamed Amine Ismail <amine.ismail@sophia.inria.fr>
  */
+
 #ifndef UDP_CLIENT_SERVER_HELPER_H
 #define UDP_CLIENT_SERVER_HELPER_H
 
-#include "ns3/application-container.h"
-#include "ns3/ipv4-address.h"
-#include "ns3/node-container.h"
-#include "ns3/object-factory.h"
-#include "ns3/udp-client.h"
-#include "ns3/udp-server.h"
+#include <ns3/application-helper.h>
+#include <ns3/udp-client.h>
+#include <ns3/udp-server.h>
+#include <ns3/udp-trace-client.h>
 
 #include <stdint.h>
 
@@ -36,7 +35,7 @@
  *        and uses the information carried into their payload to compute
  *        delay and to determine if some packets are lost.
  */
-class UdpServerHelper
+class UdpServerHelper : public ApplicationHelper
 {
   public:
     /**
@@ -53,38 +52,6 @@
      * \param port The port the server will wait on for incoming packets
      */
     UdpServerHelper(uint16_t port);
-
-    /**
-     * Record an attribute to be set in each Application after it is is created.
-     *
-     * \param name the name of the attribute to set
-     * \param value the value of the attribute to set
-     */
-    void SetAttribute(std::string name, const AttributeValue& value);
-
-    /**
-     * Create one UDP server application on each of the Nodes in the
-     * NodeContainer.
-     *
-     * \param c The nodes on which to create the Applications.  The nodes
-     *          are specified by a NodeContainer.
-     * \returns The applications created, one Application per Node in the
-     *          NodeContainer.
-     */
-    ApplicationContainer Install(NodeContainer c);
-
-    /**
-     * \brief Return the last created server.
-     *
-     * This function is mainly used for testing.
-     *
-     * \returns a Ptr to the last created server application
-     */
-    Ptr<UdpServer> GetServer();
-
-  private:
-    ObjectFactory m_factory; //!< Object factory.
-    Ptr<UdpServer> m_server; //!< The last created server application
 };
 
 /**
@@ -93,7 +60,7 @@
  *  a 32bit sequence number and a 64 bit time stamp.
  *
  */
-class UdpClientHelper
+class UdpClientHelper : public ApplicationHelper
 {
   public:
     /**
@@ -113,7 +80,7 @@
      * \param port The port number of the remote UDP server
      */
 
-    UdpClientHelper(Address ip, uint16_t port);
+    UdpClientHelper(const Address& ip, uint16_t port);
     /**
      *  Create UdpClientHelper which will make life easier for people trying
      * to set up simulations with udp-client-server. Use this variant with
@@ -123,27 +90,7 @@
      * \param addr The address of the remote UDP server
      */
 
-    UdpClientHelper(Address addr);
-
-    /**
-     * Record an attribute to be set in each Application after it is is created.
-     *
-     * \param name the name of the attribute to set
-     * \param value the value of the attribute to set
-     */
-    void SetAttribute(std::string name, const AttributeValue& value);
-
-    /**
-     * \param c the nodes
-     *
-     * Create one UDP client application on each of the input nodes
-     *
-     * \returns the applications created, one application per input node.
-     */
-    ApplicationContainer Install(NodeContainer c);
-
-  private:
-    ObjectFactory m_factory; //!< Object factory.
+    UdpClientHelper(const Address& addr);
 };
 
 /**
@@ -158,7 +105,7 @@
  * \li -3- the third one indicates the time on which the frame was generated by the encoder
  * \li -4- the fourth one indicates the frame size in byte
  */
-class UdpTraceClientHelper
+class UdpTraceClientHelper : public ApplicationHelper
 {
   public:
     /**
@@ -178,7 +125,8 @@
      * \param port The port number of the remote UDP server
      * \param filename the file from which packet traces will be loaded
      */
-    UdpTraceClientHelper(Address ip, uint16_t port, std::string filename);
+    UdpTraceClientHelper(const Address& ip, uint16_t port, const std::string& filename = "");
+
     /**
      * Create UdpTraceClientHelper which will make life easier for people trying
      * to set up simulations with udp-client-server. Use this variant with
@@ -188,27 +136,7 @@
      * \param addr The address of the remote UDP server
      * \param filename the file from which packet traces will be loaded
      */
-    UdpTraceClientHelper(Address addr, std::string filename);
-
-    /**
-     * Record an attribute to be set in each Application after it is is created.
-     *
-     * \param name the name of the attribute to set
-     * \param value the value of the attribute to set
-     */
-    void SetAttribute(std::string name, const AttributeValue& value);
-
-    /**
-     * \param c the nodes
-     *
-     * Create one UDP trace client application on each of the input nodes
-     *
-     * \returns the applications created, one application per input node.
-     */
-    ApplicationContainer Install(NodeContainer c);
-
-  private:
-    ObjectFactory m_factory; //!< Object factory.
+    UdpTraceClientHelper(const Address& addr, const std::string& filename = "");
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/helper/udp-echo-helper.cc ns-3.42/src/applications/helper/udp-echo-helper.cc
--- ns-3.41/src/applications/helper/udp-echo-helper.cc	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/helper/udp-echo-helper.cc	2024-05-29 15:29:46.920073000 -0700
@@ -16,9 +16,9 @@
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
+
 #include "udp-echo-helper.h"
 
-#include "ns3/names.h"
 #include "ns3/udp-echo-client.h"
 #include "ns3/udp-echo-server.h"
 #include "ns3/uinteger.h"
@@ -27,72 +27,26 @@
 {
 
 UdpEchoServerHelper::UdpEchoServerHelper(uint16_t port)
+    : ApplicationHelper(UdpEchoServer::GetTypeId())
 {
-    m_factory.SetTypeId(UdpEchoServer::GetTypeId());
     SetAttribute("Port", UintegerValue(port));
 }
 
-void
-UdpEchoServerHelper::SetAttribute(std::string name, const AttributeValue& value)
-{
-    m_factory.Set(name, value);
-}
-
-ApplicationContainer
-UdpEchoServerHelper::Install(Ptr<Node> node) const
-{
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-UdpEchoServerHelper::Install(std::string nodeName) const
-{
-    Ptr<Node> node = Names::Find<Node>(nodeName);
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-UdpEchoServerHelper::Install(NodeContainer c) const
-{
-    ApplicationContainer apps;
-    for (auto i = c.Begin(); i != c.End(); ++i)
-    {
-        apps.Add(InstallPriv(*i));
-    }
-
-    return apps;
-}
-
-Ptr<Application>
-UdpEchoServerHelper::InstallPriv(Ptr<Node> node) const
-{
-    Ptr<Application> app = m_factory.Create<UdpEchoServer>();
-    node->AddApplication(app);
-
-    return app;
-}
-
-UdpEchoClientHelper::UdpEchoClientHelper(Address address, uint16_t port)
+UdpEchoClientHelper::UdpEchoClientHelper(const Address& address, uint16_t port)
+    : ApplicationHelper(UdpEchoClient::GetTypeId())
 {
-    m_factory.SetTypeId(UdpEchoClient::GetTypeId());
     SetAttribute("RemoteAddress", AddressValue(address));
     SetAttribute("RemotePort", UintegerValue(port));
 }
 
-UdpEchoClientHelper::UdpEchoClientHelper(Address address)
+UdpEchoClientHelper::UdpEchoClientHelper(const Address& address)
+    : ApplicationHelper(UdpEchoClient::GetTypeId())
 {
-    m_factory.SetTypeId(UdpEchoClient::GetTypeId());
     SetAttribute("RemoteAddress", AddressValue(address));
 }
 
 void
-UdpEchoClientHelper::SetAttribute(std::string name, const AttributeValue& value)
-{
-    m_factory.Set(name, value);
-}
-
-void
-UdpEchoClientHelper::SetFill(Ptr<Application> app, std::string fill)
+UdpEchoClientHelper::SetFill(Ptr<Application> app, const std::string& fill)
 {
     app->GetObject<UdpEchoClient>()->SetFill(fill);
 }
@@ -112,38 +66,4 @@
     app->GetObject<UdpEchoClient>()->SetFill(fill, fillLength, dataLength);
 }
 
-ApplicationContainer
-UdpEchoClientHelper::Install(Ptr<Node> node) const
-{
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-UdpEchoClientHelper::Install(std::string nodeName) const
-{
-    Ptr<Node> node = Names::Find<Node>(nodeName);
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-UdpEchoClientHelper::Install(NodeContainer c) const
-{
-    ApplicationContainer apps;
-    for (auto i = c.Begin(); i != c.End(); ++i)
-    {
-        apps.Add(InstallPriv(*i));
-    }
-
-    return apps;
-}
-
-Ptr<Application>
-UdpEchoClientHelper::InstallPriv(Ptr<Node> node) const
-{
-    Ptr<Application> app = m_factory.Create<UdpEchoClient>();
-    node->AddApplication(app);
-
-    return app;
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/applications/helper/udp-echo-helper.h ns-3.42/src/applications/helper/udp-echo-helper.h
--- ns-3.41/src/applications/helper/udp-echo-helper.h	2024-02-09 14:44:07.853789800 -0800
+++ ns-3.42/src/applications/helper/udp-echo-helper.h	2024-05-29 15:29:46.920073000 -0700
@@ -16,14 +16,11 @@
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
+
 #ifndef UDP_ECHO_HELPER_H
 #define UDP_ECHO_HELPER_H
 
-#include "ns3/application-container.h"
-#include "ns3/ipv4-address.h"
-#include "ns3/ipv6-address.h"
-#include "ns3/node-container.h"
-#include "ns3/object-factory.h"
+#include <ns3/application-helper.h>
 
 #include <stdint.h>
 
@@ -35,7 +32,7 @@
  * \brief Create a server application which waits for input UDP packets
  *        and sends them back to the original sender.
  */
-class UdpEchoServerHelper
+class UdpEchoServerHelper : public ApplicationHelper
 {
   public:
     /**
@@ -45,66 +42,13 @@
      * \param port The port the server will wait on for incoming packets
      */
     UdpEchoServerHelper(uint16_t port);
-
-    /**
-     * Record an attribute to be set in each Application after it is is created.
-     *
-     * \param name the name of the attribute to set
-     * \param value the value of the attribute to set
-     */
-    void SetAttribute(std::string name, const AttributeValue& value);
-
-    /**
-     * Create a UdpEchoServerApplication on the specified Node.
-     *
-     * \param node The node on which to create the Application.  The node is
-     *             specified by a Ptr<Node>.
-     *
-     * \returns An ApplicationContainer holding the Application created,
-     */
-    ApplicationContainer Install(Ptr<Node> node) const;
-
-    /**
-     * Create a UdpEchoServerApplication on specified node
-     *
-     * \param nodeName The node on which to create the application.  The node
-     *                 is specified by a node name previously registered with
-     *                 the Object Name Service.
-     *
-     * \returns An ApplicationContainer holding the Application created.
-     */
-    ApplicationContainer Install(std::string nodeName) const;
-
-    /**
-     * \param c The nodes on which to create the Applications.  The nodes
-     *          are specified by a NodeContainer.
-     *
-     * Create one udp echo server application on each of the Nodes in the
-     * NodeContainer.
-     *
-     * \returns The applications created, one Application per Node in the
-     *          NodeContainer.
-     */
-    ApplicationContainer Install(NodeContainer c) const;
-
-  private:
-    /**
-     * Install an ns3::UdpEchoServer on the node configured with all the
-     * attributes set with SetAttribute.
-     *
-     * \param node The node on which an UdpEchoServer will be installed.
-     * \returns Ptr to the application installed.
-     */
-    Ptr<Application> InstallPriv(Ptr<Node> node) const;
-
-    ObjectFactory m_factory; //!< Object factory.
 };
 
 /**
  * \ingroup udpecho
  * \brief Create an application which sends a UDP packet and waits for an echo of this packet
  */
-class UdpEchoClientHelper
+class UdpEchoClientHelper : public ApplicationHelper
 {
   public:
     /**
@@ -115,7 +59,7 @@
      * \param ip The IP address of the remote udp echo server
      * \param port The port number of the remote udp echo server
      */
-    UdpEchoClientHelper(Address ip, uint16_t port);
+    UdpEchoClientHelper(const Address& ip, uint16_t port);
     /**
      * Create UdpEchoClientHelper which will make life easier for people trying
      * to set up simulations with echos. Use this variant with addresses that do
@@ -123,15 +67,7 @@
      *
      * \param addr The address of the remote udp echo server
      */
-    UdpEchoClientHelper(Address addr);
-
-    /**
-     * Record an attribute to be set in each Application after it is is created.
-     *
-     * \param name the name of the attribute to set
-     * \param value the value of the attribute to set
-     */
-    void SetAttribute(std::string name, const AttributeValue& value);
+    UdpEchoClientHelper(const Address& addr);
 
     /**
      * Given a pointer to a UdpEchoClient application, set the data fill of the
@@ -145,7 +81,7 @@
      * \param app Smart pointer to the application (real type must be UdpEchoClient).
      * \param fill The string to use as the actual echo data bytes.
      */
-    void SetFill(Ptr<Application> app, std::string fill);
+    void SetFill(Ptr<Application> app, const std::string& fill);
 
     /**
      * Given a pointer to a UdpEchoClient application, set the data fill of the
@@ -183,49 +119,6 @@
      * \param dataLength The desired length of the final echo data.
      */
     void SetFill(Ptr<Application> app, uint8_t* fill, uint32_t fillLength, uint32_t dataLength);
-
-    /**
-     * Create a udp echo client application on the specified node.  The Node
-     * is provided as a Ptr<Node>.
-     *
-     * \param node The Ptr<Node> on which to create the UdpEchoClientApplication.
-     *
-     * \returns An ApplicationContainer that holds a Ptr<Application> to the
-     *          application created
-     */
-    ApplicationContainer Install(Ptr<Node> node) const;
-
-    /**
-     * Create a udp echo client application on the specified node.  The Node
-     * is provided as a string name of a Node that has been previously
-     * associated using the Object Name Service.
-     *
-     * \param nodeName The name of the node on which to create the UdpEchoClientApplication
-     *
-     * \returns An ApplicationContainer that holds a Ptr<Application> to the
-     *          application created
-     */
-    ApplicationContainer Install(std::string nodeName) const;
-
-    /**
-     * \param c the nodes
-     *
-     * Create one udp echo client application on each of the input nodes
-     *
-     * \returns the applications created, one application per input node.
-     */
-    ApplicationContainer Install(NodeContainer c) const;
-
-  private:
-    /**
-     * Install an ns3::UdpEchoClient on the node configured with all the
-     * attributes set with SetAttribute.
-     *
-     * \param node The node on which an UdpEchoClient will be installed.
-     * \returns Ptr to the application installed.
-     */
-    Ptr<Application> InstallPriv(Ptr<Node> node) const;
-    ObjectFactory m_factory; //!< Object factory.
 };
 
 } // namespace ns3
